//
//  main.cpp
//  handling_basic
//
//  Created by Masashi Morimoto on 2016/02/14.
//  Copyright © 2016年 AIT. All rights reserved.
//

/*** 画像処理サンプルプログラム ***/
#include <iostream>
#include <opencv2/opencv.hpp>

#define FILENAME "/Users/foobar/Pictures/lenna.jpg" // 画像ファイル名

int main(int argc, const char * argv[])
{
    // 画像変数の定義
    cv::Mat img;
    // 画像入力
    img = cv::imread(FILENAME, cv::IMREAD_COLOR);
    if (img.empty()) {  // 画像ファイル読み込み失敗
        printf("Cannot read image file: %s\n", FILENAME);
        return (-1);
    }
    // 位置(x,y)の画素内容を印字
    int x = 100, y = 50;
    cv::Vec3b pixel = img.at<cv::Vec3b>(y,x);
    printf("(x,y)=(%d,%d):(R,G,B)=(%d,%d,%d)\n", x, y, pixel[2],pixel[1], pixel[0]);
    //画像表示
    cv::imshow("input image", img);
    // 画像出力
    cv::imwrite("newlenna.jpg", img);
    //キー入力待ち
    cv::waitKey(0);
    return 0;
}
