//
//  sample-2_5.cpp
//  histogram
//
//  Created by sawano on 2016/03/30.
//  Copyright © 2016年 AIT. All rights reserved.
//
#include <iostream>
#include <opencv2/opencv.hpp>


#define VAL_MAX (256) //輝度値の要素数

//木の画像
#define FILENAME "histogram_tree_gray.jpg"

int main(int argc, const char * argv[]) {

    int hist[VAL_MAX]; //ヒストグラム用の配列
    //1. 画像の入力 (グレースケール)
    cv::Mat src_img = cv::imread(FILENAME, 0);
    if (src_img.empty()) { //入力失敗の場合
        return (-1);
    }
    //2. ヒストグラムの初期化
    for (int i=0; i<VAL_MAX; i++) { //輝度値の範囲で初期化
        hist[i] = 0;
    }
    //3. 画像の走査 (ヒストグラムの生成)
    for (int y=0; y<src_img.rows; y++) { //縦
        for (int x=0; x<src_img.cols; x++) { //横
            //4. ヒストグラムカウント
            hist[src_img.at<unsigned char>(y, x)]++;
        }
    }
    for (int i=0; i<VAL_MAX; i++) {
        std::cout << hist[i] << std::endl;
    }
    
    return 0;
}
