//
//  sample-2_6.cpp
//  look up table
//
//  Created by sawano on 2016/09/12.
//  Copyright © 2016年 AIT. All rights reserved.
//
#include <iostream>
#include <opencv2/opencv.hpp>


#define VAL_MAX (256) //輝度値の要素数
#define STEP (4) //ポスタリゼーションの段階数
//入力画像
#define FILENAME "input.jpg"
//ウィンドウ名
#define WINDOW_INPUT "input"
#define WINDOW_OUTPUT "output"

int main(int argc, const char * argv[]) {
    int lut[VAL_MAX]; //ルックアップテーブルの宣言
    
    //画像の入力 (グレースケール)
    cv::Mat src_img = cv::imread(FILENAME, 0);
    if (src_img.empty()) { //入力失敗の場合
        return (-1);
    }
    
    //ルックアップテーブルの生成
    for (int i=0; i<VAL_MAX; i++) {
        //ポスタリゼーション
        lut[i] = (i / (VAL_MAX / STEP)) * (VAL_MAX / STEP);
        //ネガポジ変換
        //lut[i] = (VAL_MAX-1) - i;
        printf("%d: %d\n", i, lut[i]);
    }
    
    //出力画像のメモリ確保
    cv::Mat dst_img = cv::Mat(src_img.size(), CV_8U, 1);
    
    //画像の走査 (ヒストグラムの生成)
    for (int y=0; y<src_img.rows; y++) { //縦
        for (int x=0; x<src_img.cols; x++) { //横
            dst_img.at<unsigned char>(y, x) = lut[src_img.at<unsigned char>(y, x)];
        }
    }
    //画像の表示
    cv::imshow(WINDOW_INPUT, src_img);
    cv::imshow(WINDOW_OUTPUT, dst_img);
    cv::waitKey(); //キー入力待ち
    cv::imwrite("posterization.jpg", dst_img); //画像の保存
    
    return 0;
}
