//
//  sample-3_2.cpp
//  median_filter
//
//  Created by sawano on 2016/04/02.
//  Copyright © 2016年 AIT. All rights reserved.
//
#include <iostream>
#include <opencv2/opencv.hpp>


#define VAL_MAX (256) //輝度値の要素数
#define N (2) //フィルタサイズを決定する数値．フィルタサイズは(2N+1)になる

//木の画像
#define FILENAME "histogram_tree_gray.jpg"

int main(int argc, const char * argv[]) {
    int u, v, x, y; //ループ用変数
    
    //画像の入力 (グレースケール)
    cv::Mat src_img = cv::imread(FILENAME, 0);
    if (src_img.empty()) { //入力失敗の場合
        return (-1);
    }
    ///メディアンフィルタ
    cv::Mat h = cv::Mat_<unsigned char>((2*N+1)*(2*N+1), 1);
    //出力画像のメモリ確保
    cv::Mat dst_img = cv::Mat(src_img.size(), CV_8U, 1);
    //画像の走査
    for (y=0; y<src_img.rows; y++) {
        for (x=0; x<src_img.cols; x++) {
            //画像端の処理
            if (x<N || y<N || x>src_img.cols-1-N || y>src_img.rows-1-N) {
                dst_img.at<unsigned char>(y, x) = 0; //画像端は計算不可
                continue;
            }
            //ソート後の値が格納される変数
            cv::Mat h_dst = cv::Mat_<unsigned char>((2*N+1)*(2*N+1), 1);
            //フィルタのループ
            for (v=-N; v<=N; v++) {
                for (u=-N; u<=N; u++) {
                    //値の挿入
                    h.at<unsigned char>((v+N)*(2*N+1)+(u+N)) = src_img.at<unsigned char>(v+y, u+x);
                }
            }
            //フィルタ内の値のソート (OpenCV関数)
            cv::sort(h, h_dst, CV_SORT_EVERY_COLUMN|CV_SORT_ASCENDING);
            //メディアンの値の出力
            dst_img.at<unsigned char>(y, x) = h_dst.at<unsigned char>((2*N+1)*(2*N+1)/2);
        }
    }
    
    //表示
    cv::imshow("input", src_img);
    cv::imshow("output", dst_img);
    cv::waitKey(); //キー入力待ち
    cv::imwrite("median5x5.jpg", dst_img);
    
    return 0;
}
