//
//  sample-4_1.cpp
//  div_filter
//
//  Created by sawano on 2016/04/02.
//  Copyright © 2016年 AIT. All rights reserved.
//
#include <iostream>
#include <opencv2/opencv.hpp>

#define VAL_MAX (256) //輝度値の要素数
#define N (1) //フィルタサイズを決定する数値．フィルタサイズは(2N+1)になる
#define FILENAME "edge_input_gray.jpg"
#define M (3) //定数倍 (強調用)

int main(int argc, const char * argv[]) {
    int u, v, x, y; //ループ用変数
    //画像の入力 (グレースケール)
    cv::Mat src_img = cv::imread(FILENAME, 0);
    if (src_img.empty()) { //入力失敗の場合
        return (-1);
    }
    //微分フィルタ (横方向)
    cv::Mat h = (cv::Mat_<double>(3, 3) << 0, 0, 0, -1, 0, 1, 0, 0, 0);
    std::cout << "m=" << h << std::endl; //フィルタの確認用
    
    //出力画像のメモリ確保
    cv::Mat dst_img = cv::Mat(src_img.size(), CV_8U, 1);
    //画像の走査
    for (y=0; y<src_img.rows; y++) {
        for (x=0; x<src_img.cols; x++) {
            //画像端の処理
            if (x==0 || y==0 || x==src_img.cols-1 || y==src_img.rows-1) {
                dst_img.at<unsigned char>(y, x) = 0; //画像端は計算不可
                continue;
            }
            double tmp = 0;
            //フィルタのループ
            for (v=-N; v<=N; v++) {
                for (u=-N; u<=N; u++) {
                    tmp += (h.at<double>(v+N, u+N) * (double)src_img.at<unsigned char>(v+y, u+x));
                }
            }
            tmp = M * fabs(tmp); //定数倍 x 絶対値
            //負もしくは輝度値の最大値を超えない処理
            if ((int)tmp < 0){               tmp = 0;
            }else if ((int)tmp >= VAL_MAX) {  tmp = VAL_MAX - 1;}
            
            dst_img.at<unsigned char>(y, x) = (unsigned char)tmp;
        }
    }
    //画像の表示
    cv::imshow("input", src_img);
    cv::imshow("output", dst_img);
    cv::waitKey(); //キー入力待ち
    cv::imwrite("edge_vertical.jpg", dst_img);
    
    return 0;
}
