//
//  main.cpp
//  extract_color_basic
//
//  Created by Masashi Morimoto on 2016/03/24.
//  Copyright © 2016年 AIT. All rights reserved.
//

/*** しきい値処理による領域抽出のプログラム ***/
#include <iostream>
#include <opencv2/opencv.hpp>

#define FILENAME "/Users/foobar/Pictures/fruit_image.jpg" // 画像ファイル名

int main(int argc, const char ** argv)
{
    // 変数定義
    cv::Mat src_img, dst_img;
    cv::Vec3b val;
    // 画像入力
    src_img = cv::imread(FILENAME, cv::IMREAD_COLOR);
    if (src_img.empty()) {  // 画像ファイル読み込み失敗
        printf("Cannot read image file: %s\n", FILENAME);
        return (-1);
    }
    dst_img = cv::Mat::zeros(src_img.size(), CV_8UC1);  // 出力画像（初期値ゼロ）

    // RGB空間で赤色を検出
    for(int y = 0; y < src_img.rows; y++) {
        for(int x = 0; x < src_img.cols; x++) {
            val = src_img.at<cv::Vec3b>(y,x);
            if (val[0] >= 50 && val[0] <= 100 && val[1] >= 30 && val[1] <= 100 && val[2] >= 100) {
                dst_img.at<unsigned char>(y,x) = 255;
            }
        }
    }
    
    //画像表示
    cv::imshow("input image", src_img);
    cv::imshow("extracted region", dst_img);
    //キー入力待ち
    cv::waitKey(0);
    return (0);
}

