//
//  sample-9_1.cpp
//動画を入力してフレーム間差分を行うプログラム
//
//  Created by Yasuyuki Miura on 2016/09/12.
//  Copyright @ 2016年 SIT. All rights reserved.
//

#include <iostream>
#include <opencv2/opencv.hpp>

//①ライブラリのインストール
#pragma comment(lib,"opencv_videoio300.lib")

int main(int argc, const char* argv[]) {

	cv::Mat prev;	//１つ前のフレームの配列
	cv::Mat curr;	//現在のフレームの配列
	cv::Mat pgray;	//１つ前のフレームのグレイスケール画像
	cv::Mat cgray;	//現在のフレームのグレイスケール画像
	cv::Mat diff;	//フレーム間差分後の画像

	//②取り込む動画ファイルを開く
	cv::VideoCapture capture("movie.avi"); 

	capture >> curr;		//ファイルから1フレーム分の画像を配列currに取り込む
	//グレイスケールに変換
	cv::cvtColor(curr,cgray,CV_BGR2GRAY); 

	while(1) {

		cgray.copyTo(pgray);		//③直前のフレームをコピー
		capture >> curr;			//④1フレームの画像を取り込む
		if(curr.empty()) break;	
		//⑤グレイスケールに変換
		cv::cvtColor(curr,cgray,CV_BGR2GRAY); 
    
		cv::absdiff(cgray,pgray,diff);	//⑥フレーム間差分を実行
    
		cv::imshow("src",curr);			//入力画像を表示
		cv::imshow("diff",diff);		//⑦差分後の画像を表示

		if(cv::waitKey(1)>=0) break;

	}

	return 0;

}
