//
//  sample-9_1.cpp
//ブロック・マッチング法
//
//  Created by Yasuyuki Miura on 2016/09/12.
//  Copyright @ 2016年 SIT. All rights reserved.
//

#include<iostream>

#define HEIGHT	480					//画像の高さ
#define WIDTH	640					//画像の幅
#define N        16					//一つの領域の範囲
#define N_d      64					//探索の範囲
#define MAX_VALUE 1000000

unsigned char I_1[WIDTH][ HEIGHT];	//直前フレームの画素値
unsigned char I_2[WIDTH][ HEIGHT];	//現在フレームの画素値
int gosa_min[WIDTH][ HEIGHT];		//誤差
double v_x[WIDTH][ HEIGHT];			//オプティカル・フローのx成分
double v_y[WIDTH][ HEIGHT];			//オプティカル・フローのy成分

int calc_gosa(int x, int y, int x2, int y2){
	//誤差の計算
	int i, j;
    int gosa_r = 0;

	for(j=0; j<N; j++){
        for(i=0; i<N; i++){
            gosa_r += abs(I_1[x+i][y+j] ? I_2[x2+i][y2+j]);
		}
	}
	return gosa_r;
}

void main(int argc, const char *argv[]){
    int i, j, x, y;
    int gosa;

	for(y=0; y<HEIGHT; y+=N){
        for(x=0; x<WIDTH; x+=N){
            gosa_min[x][y] = MAX_VALUE;
            v_x[x][y] = -N_d;
            v_y[x][y] = -N_d;
            for(j= -N_d; j<= N_d; j++){
                for(i=-N_d; i<= N_d; i++){
                    gosa = calc_gosa(x, y, x+i, y+j);
                    if(gosa<gosa_min[x][y]){
						gosa_min[x][y] = gosa;
						v_x[x][y] = i;
						v_y[x][y] = j;
					}
                }
			}
		}
    }
    return;
}
