//
//  sample6-2.cpp
//  DCT 
//
//  Created by Tsutomu Horikoshi on 2016/11/13.
//  Copyright © 2016年 SIT. All rights reserved.
//

/***高周波数成分を削除する離散コサイン変換のプログラム***/

#include <iostream>
#include "opencv2/opencv.hpp"

#define FILENAME "Users/foobar/Pictures/lenna.jpg"

int main(int argc, char * argv[])
{	
	// 変数定義
	cv::Mat src_img,src_img2,dst_img;
	cv::Mat pow_spc;
	
	//画像入力
	src_img = cv::imread(FILENAME, cv::IMREAD_GRAYSCALE);
	if( src_img.empty()){ //画像ファイル読み込み失敗
		printf("Cannot read image file: %s\n", FILENAME);		
		return (-1);
	}	
	
	//読み込んだ画像の画素値を実数型に変換する
	src_img.convertTo(src_img2, CV_32F);
	
	//離散フーリエ変換
	cv::dct(src_img2, pow_spc);
	
	//フィルタ処理：
	//x，y共に，0〜Startの画素までのパワースペクトルの値以外を全てゼロに置き換える例
	int Start=180;
	
	for (int y=Start; y<pow_spc.rows; y++)
	{
		for (int x=0; x<pow_spc.cols; x++)
		{
			pow_spc.at<float>(y,x) = 0.0;
		}
	}
	for (int x=Start; x<pow_spc.cols; x++)
	{
		for (int y=0; y<pow_spc.rows; y++)
		{
			{
				pow_spc.at<float>(y,x) = 0.0;
			}
		}
	}
	
	// 逆離散コサイン変換	
	cv::idct(pow_spc, dst_img);
	
	// パワースペクトルを画像として保存
	cv::imwrite("pow_spc.bmp", pow_spc);	
	cv::imwrite("DCT.bmp", dst_img);
	
	
	//　画面に表示するために画素値を正規化する
	cv::normalize(dst_img, dst_img, 0, 1, cv::NORM_MINMAX); 
	cv::imshow("Original",src_img);
	cv::imshow("DCT.bmp",dst_img);
	
	cv::imshow("pow",pow_spc);
	
	
	cv::waitKey(0);
	
	return 0;
}