//
//  sample8-1.cpp
//  アフィン変換
//
//  Created by Tsutomu Horikoshi on 2016/11/13.
//  Copyright © 2016年 SIT. All rights reserved.
//
/***アフィン変換（拡大縮小処理）のプログラム***/

#include <iostream>
#include <opencv2/opencv.hpp>

// 画像ファイル名
#define FILENAME "Users/foobar/Pictures/lenna.jpg"


int main(int argc, const char * argv[])
{
	//変数を定義
	cv::Mat src_img, dst_img;
	
	//2x2の変換行列Mを設定
	double M[2][2]={{0.7, 0},{ 0, 0.3}};
	
	//画像入力
	src_img = cv::imread(FILENAME, cv::IMREAD_GRAYSCALE);
	if( src_img.empty()){ //画像ファイル読み込み失敗
		printf("Cannot read image file: %s\n", FILENAME);		
		return (-1);
	}	
	
	//結果出力用の画像ファイルを用意する
	dst_img.create( src_img.size(), src_img.type());
	
	for(int y=0;y<src_img.rows;y++){
		for(int x=0;x<src_img.cols;x++){
			//各画素(x,y)に変換行列Mを掛ける
			int xb=M[0][0]*x+M[0][1]*y;
			int yb=M[1][0]*x+M[1][1]*y;
			if(0<=yb && yb <src_img.rows){
				if(0<=xb && xb<src_img.cols){
					dst_img.at<unsigned char>(yb,xb)=src_img.at<unsigned char>(y,x);      
				}
			}
		}
	}
	cv::imshow("input image", src_img);
	cv::imshow("output image", dst_img);
	
	//キー入力待ち
	cv::waitKey(0);
	return (0);
}
