//
//  sample8-2.cpp
//  アフィン変換
//
//  Created by Tsutomu Horikoshi on 2016/11/13.
//  Copyright © 2016年 SIT. All rights reserved.
//

/***アフィン変換による画像を変換するプログラム****/

#include <iostream>
#include <opencv2/opencv.hpp>
#define PI 3.14159

// 画像ファイル名
#define FILENAME "Users/foobar/Pictures/lenna.jpg"

int main(int argc, const char ** argv)
{
	//変数を定義
	cv::Mat src_img, dst_img;
	
	//2x3の変換行列Mを設定
	double M[2][3]={{0.5, 0.7, 10},{0.3, 1.5, 15}};
	
	//画像入力
	src_img = cv::imread(FILENAME, cv::IMREAD_GRAYSCALE);
	if( src_img.empty()){ //画像ファイル読み込み失敗
		printf("Cannot read image file: %s\n", FILENAME);		
		return (-1);
	}	
	
	//結果出力用の画像ファイルを用意する
	dst_img.create( src_img.size()*2, src_img.type());
	
	for(int y=0;y<src_img.rows;y++){
	  for(int x=0;x<src_img.cols;x++){
	    int xb=M[0][0]*x+M[0][1]*y+M[0][2];
	    int yb=M[1][0]*x+M[1][1]*y+M[1][2];
	    dst_img.at<unsigned char>(yb,xb)=src_img.at<unsigned char>(y,x);      
	  }
	}
	cv::imshow("input image", src_img);
	cv::imshow("output image", dst_img);
	
	//キー入力待ち
	cv::waitKey(0);
	return (0);
}
