//
//  sample8-3.cpp
//  幾何学変換（合成変換）行列推定
//
//  Created by Tsutomu Horikoshi on 2016/11/13.
//  Copyright © 2016年 SIT. All rights reserved.
//
/***合成変換行列を推定するプログラム***/

#include <iostream>
#include <opencv2/opencv.hpp>

// 画像ファイル名
#define FILENAME "Users/foobar/Pictures/lenna.jpg"

int main(int argc, char *argv[])
{
	//変数を定義
	cv::Mat src_img, dst_img;
	cv::Mat affine_matrix=(cv::Mat_<double>(2,3));
	//２つの画像の対応点pts1, pts2を指定する
	cv::Point2f pts1[]={cv::Point2f(0,0), cv::Point2f(0,100), cv::Point2f(100,100)};
	cv::Point2f pts2[]={cv::Point2f(10,15), cv::Point2f(80,165), cv::Point2f(200,195)};
	
	//画像入力
	src_img = cv::imread(FILENAME, cv::IMREAD_GRAYSCALE);
	if( src_img.empty()){ //画像ファイル読み込み失敗
		printf("Cannot read image file: %s\n", FILENAME);		
		return (-1);
	}	
	
	//アフィン変換行列を求める	
	affine_matrix = cv::getAffineTransform(pts1, pts2);
	
	//求められたアフィン変換行列で画像src_imgを変換する
	cv::warpAffine(src_img, dst_img, affine_matrix, dst_img.size(), cv::INTER_LINEAR, cv::BORDER_CONSTANT, cv::Scalar::all(255));
	
	cv::imshow("input image", src_img);
	cv::imshow("output image", dst_img);
	
	cv::waitKey(0);
	
	return (0);
}

