//
//  sample8-4.cpp
//  透視変換
//
//  Created by Tsutomu Horikoshi on 2016/11/13.
//  Copyright © 2016年 SIT. All rights reserved.

///***透視変換を行うプログラム***/

#include <iostream>
#include<opencv2/opencv.hpp>
#include<opencv2/highgui/highgui.hpp>

// 画像ファイル名
#define FILENAME "Users/foobar/Pictures/lenna.jpg"

int main(int argc, const char *argv[] )
{
	
	// 変換行列を定義
	cv::Mat matrix( 2, 4, CV_32FC1 );
	//　入出力画像を定義
	cv::Mat src_img, dst_img;
	
	//画像入力
	src_img = cv::imread( FILENAME, cv::IMREAD_COLOR );
	if( src_img.empty()){ //画像ファイル読み込み失敗
		printf("Cannot read image file: %s\n", FILENAME);		
		return (-1);
	}	

	// 変換行列を初期化
	matrix = cv::Mat::zeros( src_img.rows, src_img.cols, src_img.type() );
	
	//変換対象の4点を指定
	cv::Point2f inputPoints[]={cv::Point(10,10), cv::Point(400,10), cv::Point(400,380), cv::Point(10,380)};
	cv::Point2f outputPoints[]={cv::Point(100,80), cv::Point(310,80), cv::Point(400,380), cv::Point(10,380)};
	
	// 変換行列matrixを計算 
	matrix = cv::getPerspectiveTransform( inputPoints, outputPoints );
	
	// 求めた変換行列matrixを使って入力画像src_imgを変換
	cv::warpPerspective(src_img,dst_img,matrix,dst_img.size() );
	
	//画像の表示
	cv::imshow("Input image",src_img);
	cv::imshow("Output image",dst_img);
	
	cv::waitKey(0);
	return (0);
}
 
